unit D290conv;
{written for HNSKY quickly from some modules, Han K, 21-2-2015}  
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls;

type
  TMain_form = class(TForm)
    Button1: TButton;
    RadioGroup1: TRadioGroup;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton4: TRadioButton;
    magedit: TEdit;
    Label1: TLabel;
    UpDown1: TUpDown;
    epoch1: TEdit;
    Label_epoch: TLabel;
    Label3: TLabel;
    RadioButton3: TRadioButton;
    Label2: TLabel;
    Label5: TLabel;
    StatusBar1: TStatusBar;
    powerdown_enabled: TCheckBox;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    GroupBox1: TGroupBox;
    Label13: TLabel;
    UCAC4_catalogue: TEdit;
    Tycho2_catalogue: TEdit;
    Box_tycho2: TCheckBox;
    box_UCAC4: TCheckBox;
    Label11: TLabel;
    Label12: TLabel;
    short_record1: TCheckBox;
    abbreviation: TEdit;
    Label14: TLabel;
    status1: TStaticText;
    Bevel1: TBevel;
    Label15: TLabel;
    Label4: TLabel;
    Label16: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Box_tycho2Click(Sender: TObject);
    procedure box_UCAC4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;


var
  Main_form: TMain_form;
  step, step2, maximum,mag_begin          :  real;
  bufferstring1                           : Tstrings;
  file_counter                            : integer;
implementation

{$R *.dfm}
uses   Unit_usno ,unit_290, unit_tycho2;

var
  epoch2:real;
  ra1,dec1:real;
  mag1    :integer;
  zonec : integer;
  zonestr : string;
  leadname: string;

function ShutMeDown:string;
var
  hToken : THandle;
  tkp,p : TTokenPrivileges;
  RetLen : DWord;
  ExReply: LongBool;
  Reply : DWord;
begin
  if OpenProcessToken(GetCurrentProcess,TOKEN_ADJUST_PRIVILEGES or TOKEN_QUERY,hToken) then
  begin
    if LookupPrivilegeValue(nil,'SeShutdownPrivilege',tkp .Privileges[0].Luid) then
    begin
      tkp.PrivilegeCount := 1;
      tkp.Privileges[0].Attributes := SE_PRIVILEGE_ENABLED;
      AdjustTokenPrivileges(hToken,False,tkp,SizeOf(TTokenPrivileges),p,RetLen);
      Reply := GetLastError;
      if Reply = ERROR_SUCCESS then
      begin
        ExReply:= ExitWindowsEx(EWX_POWEROFF or EWX_FORCE, 0);
        if ExReply then Result:='Shutdown Initiated'
        else
        Result:='Shutdown failed with ' + IntToStr(GetLastError);
      end;
    end;
  end;
end;

function inttostr(inp:integer): string;
begin
  str(inp,result);
end;
function realtostr(inp:real): string;
begin
  str(inp:0:5,result);
end;


PROCEDURE sortpartUCAC4(zone2:string;magn_start,step: real); {read file and find stars between magn_start and magn_start+step}
var nr_of_errors                : longint;
    nr,rastart,decstart         : integer;
    starnr :  integer;

    buf2: array[1..12] of byte;
    p2           : ^hnskyhdr290;		        { pointer to hnskyrecord }
    p3           : ^hnskyhdr290short;		        { pointer to hnskyrecord }
    file_opened,to_open : string;
    blink       : boolean;
BEGIN
  USNOfile_open:=0;
  recordposition:=0;
  file_opened:=''; {indicates of file is open}
  repeat
    read_UCAC4(main_form.ucac4_catalogue.text+'\'+zonestr,epoch2,ra1,dec1, mag1, starnr); {magnitude filter is done in UCAC routine for speed!!}
    if USNOfile_open=0  then
    begin
        if file_opened<>'' then close(Tof);{close file already open}
        if (getasynckeystate(vk_F4))<0  then halt;
        if (getasynckeystate(vk_F7))<0  then
        repeat
           main_form.status1.caption:='Paused';
           if blink then main_form.status1.color:=Clred else main_form.status1.color:=CLblack;
           if blink then blink:=false else  blink:=true;{blinker}
           sleep(500);
           Application.ProcessMessages; {allow application  to update form1 with above messages}
        until (getasynckeystate(vk_F8))<0;
        main_form.status1.caption:='Running';
        Application.ProcessMessages; {allow application  to update form1 with above messages}
        exit;
    end;
    if main_form.short_record1.checked=false then {standard 110 byte records}
    begin
      p2:= @buf2[1];			{ set pointer }
      with p2^ do
      begin
       {Star  label===========================================}
        nr:=zonec* $100000; {zone is multiply of $100000, maximum nr of UCAC4 stars in zone is 286.833 This allow 1.048.576 stars in a zone and 4096 zones using a cardinal or 2024 zones  using an integer (Tycho d32 is using negative numbers)}
        nr32:=nr+starnr;

       {Right accension===========================================}

          rastart := round(((256*256*256)-1)*(limit_radialen(ra1))/(2*pi));
        {make 3 byte word:}
        ra7 := lo(rastart);
        ra8 := hi(rastart);
        ra9 := rastart shr 16;{make 3 byte word};

        {declination===========================================}
        decstart :=round(( ((256*256*128)-1)*(dec1)/(0.5*pi)));

        {make 3 byte integer:}
        dec7 := lo(decstart);
        dec8 := hi(decstart);
        dec9 := decstart shr 16 ;{make 3 byte integer, important decstart must be longint};


//          if ((ra7=103) and (ra8=71) and (ra9=108) and (dec7=115) and (dec8=67) and (dec9=17)) then
//           writeln;


       {magnitude===========================================}
        if (((mag1/10)>25.4-2) or ((mag1/10)<-2.0)) then  inc(nr_of_errors)
        else
        begin
          mag0:= mag1;
                           {new magnitude 12.7 ==>  12.7}
                           {              12.8 ==> -12.8}
                           {              12.9 ==> -12.7}
                           {              13.0 ==> -12.6}
                           {              ..............}
                           {              23.4 ==> - 2.0 do not go further, confusion with Sirius=-1.7}


         {====write to 290  files====}
         to_open:=leadname+name290(ra1,dec1);

          if file_opened<>to_open then {dump file not open yet}
          begin {other dump file required,  close and open other section}
            if file_opened<>'' then close(Tof);{close file already open}
            assignfile(tof,to_open);{assign correct D32 file}
            filemode:=2;{read/write}
            reset(tof,1);
            seek(tof,filesize(tof));
            file_opened:=to_open;{remember file openened}
          end;
          blockwrite(tof,buf2, SizeOf(hnskyhdr290),Numwritten);
          inc(nr_of_stars);
          inc(nr_of_UC4_stars);
        end;
      end;
      {====write to D32  files end====}
    end {short_record1.checked=false}
    else
    begin  {short_record1.checked=true}
      p3:= @buf2[1];			{ set pointer }
      with p3^ do
      begin
       {Right accension===========================================}
        rastart := round(((256*256*256)-1)*(limit_radialen(ra1))/(2*pi));
        {make 3 byte word:}
        ra7 := lo(rastart);
        ra8 := hi(rastart);
        ra9 := rastart shr 16;{make 3 byte word};

        {declination===========================================}
        decstart :=round(( ((256*256*128)-1)*(dec1)/(0.5*pi)));

        {make 3 byte integer:}
        dec7 := lo(decstart);
        dec8 := hi(decstart);
        dec9 := decstart shr 16 ;{make 3 byte integer, important decstart must be longint};

       {magnitude===========================================}
        if (((mag1/10)>25.4-2) or ((mag1/10)<-2.0)) then  inc(nr_of_errors)
        else
        begin
          mag0:= mag1;
                           {new magnitude 12.7 ==>  12.7}
                           {              12.8 ==> -12.8}
                           {              12.9 ==> -12.7}
                           {              13.0 ==> -12.6}
                           {              ..............}
                           {              23.4 ==> - 2.0 do not go further, confusion with Sirius=-1.7}


         {====write to 290  files====}
         to_open:=leadname+name290(ra1,dec1);

          if file_opened<>to_open then {dump file not open yet}
          begin {other dump file required,  close and open other section}
            if file_opened<>'' then close(Tof);{close file already open}
            assignfile(tof,to_open);{assign correct D32 file}
            filemode:=2;{read/write}
            reset(tof,1);
            seek(tof,filesize(tof));
            file_opened:=to_open;{remember file openened}
          end;
          blockwrite(tof,buf2, SizeOf(hnskyhdr290short),Numwritten);
          inc(nr_of_stars);
          inc(nr_of_UC4_stars);
        end;
       {====write to D32  files end====}
      end;
    end; {short_record1.checked=true}
  until false;
END;
PROCEDURE sortpartTYCHO2(magn_start,step: real); {read file and find stars between magn_start and magn_start+step}
var nr_of_errors                : longint;
    rastart,decstart            : integer;
    nr_regio,nr_star,nr_extra   : integer;
    buf2: array[1..12] of byte;
    p2           : ^hnskyhdr290;		        { pointer to hnskyrecord }
    p3           : ^hnskyhdr290short;		    { pointer to hnskyrecord }
    file_opened,to_open : string;
    blink        : boolean;

BEGIN


  file_opened:=''; {indicates of file is open}

  repeat

    if readposition>=bufferstring1.count then {buffer processed}
    begin
      if file_opened<>'' then close(Tof);{close file already open}
      if (getasynckeystate(vk_F4))<0  then halt;

      if (getasynckeystate(vk_F7))<0  then
      repeat
        if blink then  main_form.status1.caption:='paused' else  main_form.status1.caption:='PAUSED';;
        if blink then blink:=false else  blink:=true;{blinker}
        Application.ProcessMessages; {allow application  to update form1 with above messages}
        sleep(500);
      until (getasynckeystate(vk_F8))<0;
      main_form.status1.caption:='Running';

      exit;

    end;

    if file_counter<=1 then  read_tycho2_supplement(epoch2,ra1,dec1, mag1, nr_regio,nr_star,nr_extra) {read supplement file}
                       else             read_tycho2(epoch2,ra1,dec1, mag1, nr_regio,nr_star,nr_extra);{read main file}



    if mag1<999 then  {999 check if last record is within}
    begin

      if main_form.short_record1.checked=false then {standard 110 byte records}
      begin  {short_record1.checked=false}
        p2:= @buf2[1];			{ set pointer }
        with p2^ do
        begin
         {Star label===========================================}
          if nr_extra=2 then nr_extra:=$40000000
          else
          if nr_extra=3 then nr_extra:=$00008000  {required for tycho-2}
          else nr_extra:=0;
          nr32:=-((nr_regio shl 16) + nr_extra + nr_star); {minus indicates GSC/TYCHO number}
//        If  the NR32 integer is positive it contains an UCAC4 number. The the star number the zone is added as a multiply of  $100000.
//        The maximum nr of UCAC4 stars in a zone is 286.833 This allow 1.048.576 stars in a zone and 4096 zones using a cardinal or 2024 zones  using an integer
//        In case the NR32 integer is negative, the integer contains the Tycho/GSC label. After making the integer positive, the regional star number is stored
//        in the lowest 2 bytes, the GSC/Tycho star region (1..9537) is stored in the highest 2 bytes except that if bit $40000000 is true, the Tycho specific extension is 2,
//        else the Tycho extension is 1. The highest bit of star number at $00008000 is used for the Tycho-2 extension 3.

         {Right accension===========================================}
          rastart := round(((256*256*256)-1)*(limit_radialen(ra1))/(2*pi));
          {make 3 byte word:}
          ra7 := lo(rastart);
          ra8 := hi(rastart);
          ra9 := rastart shr 16;{make 3 byte word};

          {declination===========================================}

          decstart :=round(( ((256*256*128)-1)*(dec1)/(0.5*pi)));

          {make 3 byte integer:}
          dec7 := lo(decstart);
          dec8 := hi(decstart);
          dec9 := decstart shr 16 ;{make 3 byte integer, important decstart must be longint};

         {magnitude===========================================}

          if (((mag1/10)>25.4-2) or ((mag1/10)<-2.0)) then  inc(nr_of_errors)
          else
          begin
            mag0:= mag1;
                         {new magnitude 12.7 ==>  12.7}
                         {              12.8 ==> -12.8}
                         {              12.9 ==> -12.7}
                         {              13.0 ==> -12.6}
                         {              ..............}
                         {              23.4 ==> - 2.0 do not go further, confusion with Sirius=-1.7}


           {====write to D32  files====}
           to_open:=leadname+name290(ra1,dec1);

           if file_opened<>to_open then {dump file not open yet}
           begin {other dump file required,  close and open other section}
             if file_opened<>'' then close(Tof);{close file already open}
             assignfile(tof,to_open);{assign correct D32 file}
             filemode:=2;{read/write}
             reset(tof,1);
             seek(tof,filesize(tof));
             file_opened:=to_open;{remember file openened}
           end;
           blockwrite(tof,buf2, SizeOf(hnskyhdr290),Numwritten);
           inc(nr_of_stars);
           {====write to D32  files end====}
         end;
       end;
     end {short_record1.checked=false}
     else
     begin {short_record1.checked=true}
        p3:= @buf2[1];			{ set pointer }
        with p3^ do
        begin
         {Star label===========================================}
         {Right accension===========================================}
          rastart := round(((256*256*256)-1)*(limit_radialen(ra1))/(2*pi));
          {make 3 byte word:}
          ra7 := lo(rastart);
          ra8 := hi(rastart);
          ra9 := rastart shr 16;{make 3 byte word};

          {declination===========================================}

          decstart :=round(( ((256*256*128)-1)*(dec1)/(0.5*pi)));

          {make 3 byte integer:}
          dec7 := lo(decstart);
          dec8 := hi(decstart);
          dec9 := decstart shr 16 ;{make 3 byte integer, important decstart must be longint};

         {magnitude===========================================}

          if (((mag1/10)>25.4-2) or ((mag1/10)<-2.0)) then  inc(nr_of_errors)
          else
          begin
            mag0:= mag1;
                         {new magnitude 12.7 ==>  12.7}
                         {              12.8 ==> -12.8}
                         {              12.9 ==> -12.7}
                         {              13.0 ==> -12.6}
                         {              ..............}
                         {              23.4 ==> - 2.0 do not go further, confusion with Sirius=-1.7}


           {====write to D32  files====}
           to_open:=leadname+name290(ra1,dec1);

           if file_opened<>to_open then {dump file not open yet}
           begin {other dump file required,  close and open other section}
             if file_opened<>'' then close(Tof);{close file already open}
             assignfile(tof,to_open);{assign correct D32 file}
             filemode:=2;{read/write}
             reset(tof,1);
             seek(tof,filesize(tof));
             file_opened:=to_open;{remember file openened}
           end;
           blockwrite(tof,buf2, SizeOf(hnskyhdr290short),Numwritten);
           inc(nr_of_stars);
           {====write to D32  files end====}
         end;
       end;




     end; {short_record1.checked=true}


   end; {good star}
   until false;
END;

function strtostr_divide10(s1:string):string; {this give much smaller exe file then using strtofloat}
var
   err:integer; r:real;
begin
  val(s1,r,err);
  if err=0 then
  begin
    r:=r/10;
    str(r:0:1,result);
  end;
end;

function floattostr_one_digit(r:real):string;
begin
    str(r:0:1,result);
end;
procedure writetextfile(new1:boolean; message1:string);
var F: TextFile;
begin
  AssignFile(F,'result.txt');
  if new1 then Rewrite(F) {clear previous info}
          else Append(f);
  Writeln(F,formatdatetime('c', now)+', '+message1);
  Flush(f);  { Ensures that the text was actually written to file. }
  CloseFile(F);
end;
procedure TMain_form.Box_tycho2Click(Sender: TObject);
begin
  if (box_tycho2.checked) then abbreviation.text:='tyc' else abbreviation.text:='uc4';
end;

procedure TMain_form.box_UCAC4Click(Sender: TObject);
begin
  if (box_tycho2.checked) then abbreviation.text:='tyc' else abbreviation.text:='uc4';
end;

procedure TMain_form.Button1Click(Sender: TObject);
var
  error2 : integer;
  i      : integer;
  name1,record_text  : string;
  info1  : array[0..112] of ansichar;

begin
  writetextfile(true,'Started');{clear previous message}
  main_form.status1.caption:='Running';
  nr_of_stars:=0;
  nr_of_UC4_stars:=0;
  nr_of_skipped:=0;
  if radiobutton1.Checked then step2:=0.1
  else
  if radiobutton2.Checked then step2:=1
  else
  if radiobutton3.Checked then step2:=3
  else
  if radiobutton4.Checked then step2:=25;{no magnitude sorting dump all stars as found in D32 files}


  val(epoch1.text,epoch2,error2);
  if error2<>0 then
  begin
    epoch1.color:=clred;
    exit;
  end
  else
  epoch1.color:=clwindow;

  maximum:=updown1.position/10;

  if ((box_tycho2.checked) and (FileExists(tycho2_catalogue.text+'\'+tycho_files[3])=false)) then {some pre checks}
  begin
    if Application.MessageBox('Can not find Tycho-2 catalogue input file "tyc2.dat.00", continue ?','Error',	MB_YESNO Or MB_ICONQUESTION or MB_ICONEXCLAMATION) = IDNO then halt;
  end;

  if (((box_ucac4.checked) and (FileExists(main_form.ucac4_catalogue.text+'\z001')=false))) then {some pre checks}
  begin
    if Application.MessageBox('Can not find UCAC4 catalogue input file "z001", continue ?','Error',	MB_YESNO Or MB_ICONQUESTION or MB_ICONEXCLAMATION) = IDNO then halt;
  end;

  leadname:=abbreviation.text+'_' ;{tyc_}

  {make header begin===========================================================}
  if main_form.short_record1.Checked then record_text:=', Record size 7 bytes, no star ID.' else record_text:=', Record size 11 bytes, standard version.';{info only}

  if ((box_tycho2.checked) and (box_ucac4.checked)) then strpcopy(info1,copy('TYCHO2 and supplementary UCAC4 stars up to magnitude '+strtostr_divide10(magedit.text) +', Epoch='+epoch1.text+record_text+'                                                                                                                                                                                                          ',1,112)){do not  override  length of info1, otherwise error at the end of program}
  else
  begin
    if (box_tycho2.checked) then strpcopy(info1,copy('TYCHO2 stars up to magnitude '+ strtostr_divide10(magedit.text) +', Epoch='+epoch1.text+record_text+'                                                                                                                                                                                                          ',1,112));{do not  override  length of info1, otherwise error at the end of program}
    if (box_ucac4.checked)  then strpcopy(info1,copy('UCAC4 stars up to magnitude '+ strtostr_divide10(magedit.text) +', Epoch='+epoch1.text+record_text+'                                                                                                                                                                                                          ',1,112));{do not  override  length of info1, otherwise error at the end of program}
  end;
  if main_form.short_record1.Checked then info1[109]:=#7 else info1[109]:=#11;{store record size binary at last byte of header}

  for i:=1 to 290 do {create,  reset output files}
  begin
    name1:=leadname+filenames290[i]; {use for destination TYC file names and not UCAC4 names}

    if ((i=1) and (FileExists(name1)=true)) then {some pre checks}
    begin
      if Application.MessageBox('Destination files exist, overwrite ?','Attention !',	MB_YESNO or MB_ICONEXCLAMATION) = IDNO then halt;
    end;

    assignfile(tof,name1);
    filemode:=2;{read/write}
    rewrite(tof,1);
    Blockwrite(tof,info1,10*SizeOf(hnskyhdr290),Numwritten);{header is 110 bytes, was 111 bytes }
    closefile(tof);
    if numwritten<>10*SizeOf(hnskyhdr290) then
    begin
      messagebox(main_form.handle,pchar('ERROR !!! Can"t create file files. Close HNSKY'),pchar('Error'),MB_ICONERROR);
      exit;
    end;
  end;
  {make header end===========================================================}

  {sort file}
  mag_begin:=-2;{start magnitude}

  repeat
    if ((mag_begin<1)  and (step2<3)) then step:=3 {speedup first part} else step:=step2;{make bigger steps before magnitude 1}
    if mag_begin+step>maximum then step:=maximum-mag_begin;{adjust step before last go.}

    if box_tycho2.checked=true then {TYCHO-2 part}
    begin
      file_counter:=0;
      repeat {do all tycho files}
        loadbuffer(tycho2_catalogue.text+'\'+tycho_files[file_counter]); {load tycho file in Tstrings}
        sortparttycho2(mag_begin,step); {read buffer and find stars between magn_start and magn_start+step}
        statusbar1.SimpleText:=('Now doing magnitude: '+floattostr_one_digit(mag_begin)+' to '+floattostr_one_digit(mag_begin+step)+'   File: '+tycho_files[file_counter]+'    Stars done: '+ inttostr(nr_of_stars)+ '   UC4_stars: '+ inttostr(nr_of_UC4_stars));
        main_form.caption:=('Now doing magnitude: '+floattostr_one_digit(mag_begin)+' to '+floattostr_one_digit(mag_begin+step)+'   File: '+tycho_files[file_counter]+'    Stars done: '+ inttostr(nr_of_stars)+ '   UC4_stars: '+ inttostr(nr_of_UC4_stars));
        Application.ProcessMessages; {allow application  to update form1 with above messages}
        inc(file_counter);
      until file_counter>=19+2+1
    end;


    if box_UCAC4.checked=true then {do UCAC4 part}
    for  zonec:=1 to 900 do
    begin
      zonestr:=inttostr(zonec+1000);
      zonestr[1]:='z'; {zone z001 .. z900}
      statusbar1.SimpleText:='';
      statusbar1.SimpleText:=('Now doing magnitude: '+floattostr_one_digit(mag_begin)+' to '+floattostr_one_digit(mag_begin+step)+'    Zone: '+zonestr+'    Stars done: '+ inttostr(nr_of_stars)+ '   UC4_stars: '+ inttostr(nr_of_UC4_stars));
      main_form.caption:=('Now doing magnitude: '+floattostr_one_digit(mag_begin)+' to '+floattostr_one_digit(mag_begin+step)+'    Zone: '+zonestr+'    Stars done: '+ inttostr(nr_of_stars)+ '   UC4_stars: '+ inttostr(nr_of_UC4_stars));
      Application.ProcessMessages; {allow application  to update form1 with above messages}
      sortpartUCAC4(zonestr, mag_begin,step); {read file and find stars between magn_start and magn_start+step}
    end;{for loop zones}
     writetextfile(false,'Up_to_mag '+floattostr(mag_begin+step)+' stars_done:'+inttostr(nr_of_stars));{write result to file}

    mag_begin:=mag_begin+step;
  until mag_begin>=maximum;
  writetextfile(false,'Ready.   Stars done:'+ inttostr(nr_of_stars));{write result to file}
  if ((powerdown_enabled.checked)and (nr_of_stars>100)) then statusbar1.simpletext:=ShutMeDown
  else
  messagebox(main_form.handle,pchar('Ready.   Stars done:'+ inttostr(nr_of_stars)),pchar('Ready'),MB_ICONINFORMATION);
  main_form.status1.caption:='Finished';

end;

procedure TMain_form.FormCreate(Sender: TObject);
begin
  bufferstring1 := Tstringlist.Create;
end;

procedure TMain_form.FormDestroy(Sender: TObject);
begin
  bufferstring1.free;{free suppl1}
end;

end.

